/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.pascal.tool;

/**/
import org.sablecc.pascal.analysis.*;
import org.sablecc.pascal.node.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;


/** 
 * GUI-based display of AST.
 * This is a simple utility that uses Java's JTree class to provide a
 * rudimentary hierarchical display of an AST built by a parser that is 
 * generated by SableCC.  See also PrintTree class.
 *@author Jeffrey Van Baalen
 *@author Mariusz Nowostawski
 */
public class DisplayTree extends DepthFirstAdapter
{

    private Hashtable table = new Hashtable();
    private DefaultMutableTreeNode root = null;

    private String stripName(Node node){
         return node.getClass().getName().substring("org.sablecc.pascal".length()+6);
    }

    // Default node creation.
    public void defaultIn(Node node) 
    {   
        table.put(node, new DefaultMutableTreeNode(stripName(node)));
    }

    public void outAProgram(AProgram node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getProgramHeading() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getProgramHeading());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getProgramHeading())+": "+node.getProgramHeading().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDeclarations() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDeclarations());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDeclarations())+": "+node.getDeclarations().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getBody() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBody());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBody())+": "+node.getBody().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDot() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDot());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDot())+": "+node.getDot().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAProgramHeading(AProgramHeading node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getProgram() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getProgram());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getProgram())+": "+node.getProgram().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getIdentifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifier())+": "+node.getIdentifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outADeclarations(ADeclarations node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getVariablesDeclaration() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVariablesDeclaration());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVariablesDeclaration())+": "+node.getVariablesDeclaration().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAVariablesDeclaration(AVariablesDeclaration node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getVar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVar())+": "+node.getVar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getVariablesDefinitionList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVariablesDefinitionList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVariablesDefinitionList())+": "+node.getVariablesDefinitionList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outASingleVariablesDefinitionList(ASingleVariablesDefinitionList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getVariablesDefinition() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVariablesDefinition());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVariablesDefinition())+": "+node.getVariablesDefinition().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMultipleVariablesDefinitionList(AMultipleVariablesDefinitionList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getVariablesDefinitionList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVariablesDefinitionList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVariablesDefinitionList())+": "+node.getVariablesDefinitionList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getVariablesDefinition() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getVariablesDefinition());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getVariablesDefinition())+": "+node.getVariablesDefinition().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAVariablesDefinition(AVariablesDefinition node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIdentifierList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifierList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifierList())+": "+node.getIdentifierList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getColon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getColon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getColon())+": "+node.getColon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getType() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getType());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getType())+": "+node.getType().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outASingleIdentifierList(ASingleIdentifierList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIdentifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifier())+": "+node.getIdentifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMultipleIdentifierList(AMultipleIdentifierList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIdentifierList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifierList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifierList())+": "+node.getIdentifierList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getComma() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getComma());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getComma())+": "+node.getComma().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getIdentifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifier())+": "+node.getIdentifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAType(AType node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getInteger() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getInteger());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getInteger())+": "+node.getInteger().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outABody(ABody node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getBegin() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBegin());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBegin())+": "+node.getBegin().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getStatementSequence() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStatementSequence());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStatementSequence())+": "+node.getStatementSequence().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getEnd() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getEnd());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getEnd())+": "+node.getEnd().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outASingleStatementSequence(ASingleStatementSequence node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getStatement() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStatement());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStatement())+": "+node.getStatement().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMultipleStatementSequence(AMultipleStatementSequence node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getStatementSequence() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStatementSequence());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStatementSequence())+": "+node.getStatementSequence().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getStatement() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStatement());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStatement())+": "+node.getStatement().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAWritelnStatement(AWritelnStatement node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getWriteln() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getWriteln());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getWriteln())+": "+node.getWriteln().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getLParen() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLParen());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLParen())+": "+node.getLParen().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getExpression() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getExpression());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getExpression())+": "+node.getExpression().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRParen() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRParen());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRParen())+": "+node.getRParen().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAAssignmentStatement(AAssignmentStatement node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIdentifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifier())+": "+node.getIdentifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getAssignop() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAssignop());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAssignop())+": "+node.getAssignop().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getExpression() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getExpression());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getExpression())+": "+node.getExpression().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAEmptyStatement(AEmptyStatement node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
    }

    public void outATermExpression(ATermExpression node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getTerm() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTerm());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTerm())+": "+node.getTerm().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPlusExpression(APlusExpression node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getExpression() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getExpression());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getExpression())+": "+node.getExpression().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getPlus() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPlus());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPlus())+": "+node.getPlus().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTerm() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTerm());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTerm())+": "+node.getTerm().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMinusExpression(AMinusExpression node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getExpression() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getExpression());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getExpression())+": "+node.getExpression().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getMinus() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getMinus());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getMinus())+": "+node.getMinus().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTerm() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTerm());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTerm())+": "+node.getTerm().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAFactorTerm(AFactorTerm node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getFactor() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getFactor());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getFactor())+": "+node.getFactor().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMultTerm(AMultTerm node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getTerm() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTerm());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTerm())+": "+node.getTerm().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getMult() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getMult());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getMult())+": "+node.getMult().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getFactor() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getFactor());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getFactor())+": "+node.getFactor().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outADivTerm(ADivTerm node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getTerm() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTerm());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTerm())+": "+node.getTerm().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDiv() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDiv());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDiv())+": "+node.getDiv().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getFactor() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getFactor());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getFactor())+": "+node.getFactor().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAIdentifierFactor(AIdentifierFactor node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIdentifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdentifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdentifier())+": "+node.getIdentifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outANumberFactor(ANumberFactor node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getNumber() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getNumber());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getNumber())+": "+node.getNumber().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAExpressionFactor(AExpressionFactor node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLParen() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLParen());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLParen())+": "+node.getLParen().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getExpression() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getExpression());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getExpression())+": "+node.getExpression().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRParen() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRParen());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRParen())+": "+node.getRParen().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public TreeFrame getTreeFrame() 
    {
        return new TreeFrame("Abstract Syntax Tree", root);
    }

    public TreeInternalFrame getTreeInternalFrame() 
    {
        return new TreeInternalFrame("Abstract Syntax Tree", root);
    }

    public static class TreeFrame extends JFrame
    {
        public TreeFrame(String title, DefaultMutableTreeNode root)
        {
            super(title);
            //WindowUtilities.setNativeLookAndFeel();
            Container content = getContentPane();
            JTree tree = new JTree(root);
            content.add(new JScrollPane(tree), BorderLayout.CENTER);
            setSize(275, 300);
        }

    }//TreeFrame


    public static class TreeInternalFrame extends JInternalFrame 
    {
        public TreeInternalFrame(String title, DefaultMutableTreeNode root)
        {
            super(title);
            Container content = getContentPane();
            JTree tree = new JTree(root);
            content.add(new JScrollPane(tree), BorderLayout.CENTER);
            setSize(275, 300);
         }

    }//TreeInternalFrame

}//DisplayTree
